﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics;
using System.Collections.Specialized;

namespace System.Collections.Observable.DebugViews
{
    internal class ObservableDictionaryDebugView<TKey, TValue> 
    {
        ObservableDictionary<TKey, TValue> ObservableDictionary;

        [DebuggerBrowsable(DebuggerBrowsableState.Collapsed)]
        [DebuggerDisplay("{InternalCollection.Count}", Name = "Internal Dictionary")]
        public Dictionary<TKey, TValue> InternalCollection
        {
            get
            {
                return ObservableDictionary.InternalCollection;
            }
        }

        [DebuggerDisplay("{SubscribersCount}")]        
        public NotifyCollectionChangedEventHandler Subscribers
        {
            get
            {
                return ObservableDictionary.CollectionChangedSubscribers;
            }
        }

        private int SubscribersCount
        {
            get
            {
                NotifyCollectionChangedEventHandler subscribers = ObservableDictionary.CollectionChangedSubscribers;
                if (subscribers == null)
                {
                    return 0;
                }
                else
                {
                    return subscribers.GetInvocationList().Length;
                }
            }
        }

        public ObservableDictionaryDebugView(ObservableDictionary<TKey, TValue> observableDict)
        {
            ObservableDictionary = observableDict;
        }
    }
}
