﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Globalization;
using System.Windows.Data;

namespace Frontend
{
    [ValueConversion(typeof(RefreshStatus), typeof(bool))]
    class RefreshStatusToBoolConverter: IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            if (parameter == null)
            {
                return true;
            }

            if (targetType != typeof(bool))
            {
                throw new ArgumentException("Can convert only to Boolean type");
            }

            if (parameter.GetType() != typeof(RefreshStatus))
            {
                throw new ArgumentException("Custom parameter: can convert only from RefreshStatus type");
            }

            if (value.GetType() != typeof(RefreshStatus))
            {
                throw new ArgumentException("Value: can convert only from RefreshStatus type");
            }

            RefreshStatus expected = (RefreshStatus)parameter;
            RefreshStatus current = (RefreshStatus)value;

            return expected == current;
        }


        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            throw new NotSupportedException();
        }
    }
}
