﻿/****************************************************************
  Author:  Ievgenii Nazaruk, ievgenii.nazaruk@gmail.com 
 License:  Microsoft Public License (Ms-PL)
          ( http://www.opensource.org/licenses/ms-pl.html or
            http://www.microsoft.com/opensource/licenses.mspx )
*****************************************************************/

using WebLayer;
using System;
using System.Net;
using System.Diagnostics;
using System.IO;
using WebPageParser;
using TableParsers;
using Speakup;
using System.Runtime.Serialization.Formatters.Binary;
using System.Runtime.Serialization;

class Program
{
    static void Main(string[] args)
    {
        AssemblyResolvers.ProcessArchitectureBasedResolver.Activate();
        Trace.Listeners.Add(new ConsoleTraceListener());

        LoginToken loginToken = new LoginToken("****","****","4001");
        //PersonalStats stats = PersonalStats.Fetch(loginToken);

        //int i = 0;

        ClassList classes = ClassListFetcher.Fetch(loginToken);
        ClassListThemeAssigner.AssignThemes(classes, 8);

        foreach (Class c in classes)
        {
            Console.WriteLine("{0} -- {1}", c.ClassName, c.Theme);
        }
    }
}

