﻿/****************************************************************
  Author:  Ievgenii Nazaruk, ievgenii.nazaruk@gmail.com 
 License:  Microsoft Public License (Ms-PL)
          ( http://www.opensource.org/licenses/ms-pl.html or
            http://www.microsoft.com/opensource/licenses.mspx )
*****************************************************************/

using System;
using System.Collections.Generic;

namespace TableParsers
{
    public class ReservedTableEntry
    {
        public ClassName ClassName = null;
        public ClassTime ClassTime  = null;
        public int ClassId = 0;
    }

    public class ReservedTable : List<ReservedTableEntry>
    {
        public static ReservedTable Fetch(WebLayer.LoginToken loginToken)
        {
            WebPageParser.WebPageCache pageCache = new WebPageParser.WebPageCache();
            pageCache.LoginToken = loginToken;

            return Fetch(pageCache);
        }
        public static ReservedTable Fetch(WebPageParser.WebPageCache pageCache)
        {
            WebPageParser.ReservationsWebPage webPage = pageCache.GetPage<WebPageParser.ReservationsWebPage>();

            ReservedTable reservedTable = new ReservedTable();
            foreach (WebPageParser.ReservedTableEntry webEntry in webPage.ReservedTableContent)
            {
                ReservedTableEntry memEntry = new ReservedTableEntry();

                memEntry.ClassName = ClassNameParser.ParseClassName(webEntry.Class);
                memEntry.ClassTime = ClassTimeParser.ParseReservedEntry(webEntry.Date);
                memEntry.ClassId = Int32.Parse(webEntry.Cancel);

                reservedTable.Add(memEntry);
            }

            return reservedTable;
        }
    }
}
